import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Mover here.
 * 
 * @author David Monroe 
 * @version 9/18/11
 */
public class Mover extends Actor
{
    /**
     * Act - do whatever the Mover wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }

    /**
     * Test if we are close to one of the edges of the
     * world and return true if we are.
     */
    public boolean atWorldEdge()
    {
        World w = getWorld();
        if(getX() < 20 || getX() > w.getWidth() - 20)
        {
            return true;
        }
        if(getY() < 20 || getY() > w.getHeight() - 20)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    /**
     * Return true if we can see an object of class 'clss'
     * right where we are.
     * False if there is no such object here.
     */
    public boolean canSee(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;
    }

    /**
     * Try to eat an object of class 'clss'. This is only
     * successful if there is such an object at the current
     * location. Otherwise this method does nothing.
     */
    public void eat(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        if (actor != null) {
            getWorld().removeObject(actor);
        }
    }
    
    /**
     * Determines whether to turn left or right.
     */
    public void chooseTurn(int t, int b)
    {
        if (Greenfoot.getRandomNumber(100) < b) 
        {
            turn(t);
        }
        else
        {
            turn(t * -1);
        }
    }
    
    /**
     * Handles encountering the world edge.
     */
    public void edgeTurn(int t, int m)
    {
        if (atWorldEdge())
        {
            turn(t);
            move(m);
        }
    }
    
    /**
     * Determines whether to move or turn.
     * Will move more often.
     */
    public void chooseAction(int t, int m, int b)
    {
        if (Greenfoot.getRandomNumber(100) < 10)
        {
            chooseTurn(t, b);
        }
        else
        {
            move(m);
        }
    }
    
}
