import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * RedCar while always move forward but the player may turn it.
 * 
 * @author David Monroe 
 * @version 9/25/11
 */
public class RedCar extends Mover
{

private GreenfootImage image1;
private GreenfootImage image2;
private int pickups;

    /**
     * Creates a red car and initializes its variables.
     */
    public RedCar()
    {
        image1 = new GreenfootImage("car02.png");
        image2 = new GreenfootImage("skull.png");
        setImage(image1);
        pickups = 0;
    }
        
    /**
     * Act - do whatever the RedCar wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        keyCheck();
        move(4);
        crashWatch();
        lookForPickups();
    }
    
    /**
     * Checks if a key is pressed and acts accordingly.
     */
    public void keyCheck()
    {
        if (Greenfoot.isKeyDown("right"))
        {
            turn(4);
        }
        else if (Greenfoot.isKeyDown("left"))
        {
            turn(-4);
        }
    }
    
    /**
     * Watches for human fatalities.
     */
    public void crashWatch()
    {
        if (canSee(BlueMan.class))
        {
            eat(BlueMan.class);
            Greenfoot.playSound("HumanScream.mp3");
            setImage(image2);
            Greenfoot.stop();
        }
    }
    
    /**
     * Looks for an object, if found, eats it and plays an audio file.
     */
    public void lookForPickups()
    {
        if (canSee(Pickup.class))
        {
            eat(Pickup.class);
            Greenfoot.playSound("Pickup.WAV");
            pickups++;
            
            if (pickups >= 10)
            {
                Greenfoot.playSound("fanfare.wav");
                Greenfoot.stop();
            }
        }
    }
}
